<template>
  <div class="card shadow" :class="type === 'dark' ? 'bg-default' : ''">
    <div
      class="card-header border-0"
      :class="type === 'dark' ? 'bg-transparent' : ''"
    >
      <div class="row align-items-center">
        <div class="col">
          <h3 class="mb-0" :class="type === 'dark' ? 'text-white' : ''">
            {{ title }}
          </h3>
        </div>
      </div>
    </div>

    <div class="table-responsive">
      <v-app id="inspire">
        <v-card>
          <v-data-table
            :headers="headers"
            :items="students"
            :items-per-page="10"
            class="elevation-1"
            :search="search"
            item-key="id"
            show-expand
            single-expand
            :single-exand="singleExpand"
            :expanded.sync="expanded"
          >
            <template v-slot:expanded-item="{ headers, item }">
              <td :colspan="headers.length">
                <students-details :item="item"></students-details>
              </td>
            </template>
            <template v-slot:[`item.active`]="{ item }">
              <v-chip :color="getActiveColor(item.active)" dark>
                {{ item.active }}
              </v-chip>
            </template>
            <template v-slot:[`item.images`]="{ item }">
              <v-img :src="item.images" width="20px" />
            </template>

            <template v-slot:[`body.prepend`]>
              <tr>
                <td><v-icon>mdi-filter-variant</v-icon></td>
                <td></td>
                <td>
                  <v-text-field
                    v-model="name"
                    type="text"
                    label="Name"
                  ></v-text-field>
                </td>
                <td>
                  <v-select
                    :items="genderlistFilter"
                    v-model="genderFilter"
                    label="Gender"
                  ></v-select>
                </td>
                <td>
                  <v-text-field
                    v-model="car"
                    type="text"
                    label="Car"
                  ></v-text-field>
                </td>
                <td>
                  <v-text-field
                    v-model="start"
                    type="text"
                    label="Start"
                  ></v-text-field>
                </td>
                <td>
                  <v-select
                    :items="active"
                    v-model="activeFilter"
                    label="Active"
                  ></v-select>
                </td>
              </tr>
            </template>

            <template v-slot:top>
              <v-toolbar flat>
                <v-row>
                  <v-col col="5">
                    <v-dialog v-model="dialog" max-width="500px">
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          color="primary"
                          dark
                          class="mb-2"
                          v-bind="attrs"
                          v-on="on"
                        >
                          New Student
                        </v-btn>
                      </template>
                      <v-card>
                        <v-card-title>
                          <span class="headline">{{ formTitle }}</span>
                        </v-card-title>

                        <v-card-text>
                          <v-container>
                            <v-row>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field
                                  v-model="editedItem.full_name"
                                  label="Name"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-select
                                  :items="gender"
                                  v-model="editedItem.gender"
                                  label="Gender"
                                ></v-select>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field
                                  v-model="editedItem.date_of_birth"
                                  label="Birthday"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field
                                  v-model="editedItem.phone_number"
                                  label="PhoneNumber"
                                ></v-text-field>
                              </v-col>
                              <v-col cols="12" sm="6" md="4">
                                <v-text-field
                                  v-model="editedItem.address"
                                  label="Address"
                                ></v-text-field>
                              </v-col>
                            </v-row>
                          </v-container>
                        </v-card-text>

                        <v-card-actions>
                          <v-spacer></v-spacer>
                          <v-btn color="blue darken-1" text @click="close">
                            Cancel
                          </v-btn>
                          <v-btn color="blue darken-1" text @click="save">
                            Save
                          </v-btn>
                        </v-card-actions>
                      </v-card>
                    </v-dialog>
                  </v-col>
                  <v-col col="7">
                    <v-text-field
                      v-model="search"
                      append-icon="mdi-magnify"
                      label="Search"
                      single-line
                      hide-details
                    ></v-text-field>
                  </v-col>
                </v-row>
              </v-toolbar>
            </template>

            <template v-slot:[`item.actions`]="{ item }">
              <v-icon color="blue" small class="mr-2" @click="editItem(item)">
                mdi-pencil
              </v-icon>
              <v-icon color="red" small @click="deleteItem(item)">
                mdi-delete
              </v-icon>
            </template>
          </v-data-table>
        </v-card>
      </v-app>
    </div>

    <div
      class="card-footer d-flex justify-content-end"
      :class="type === 'dark' ? 'bg-transparent' : ''"
    ></div>
  </div>
</template>
<script>
import StudentsDetails from "./StudentsDetails";
export default {
  name: "projects-table",
  props: {
    type: {
      type: String,
    },
    title: String,
  },
  data() {
    return {
      search: "",
      name: "",
      start: "",
      car: "",
      active: ["all", "true", "false"],
      activeFilter: "",
      genderFilter: "",
      expanded: [],
      singleExpand: false,
      gender: ["male", "female"],
      genderlistFilter: ["all", "male", "female"],
      dialog: false,
      editedIndex: -1,
      editedItem: {
        school_id: "THKĐHN",
        full_name: "",
        gender: "",
        date_of_birth: "",
        phone_number: "",
        address: "",
        images:
          "https://www.iconfinder.com/data/icons/eldorado-user/40/user-512.png",
        active: true,
      },
      defaultItem: {
        school_id: "THKĐHN",
        full_name: "",
        gender: "",
        date_of_birth: "",
        phone_number: "",
        address: "",
        images:
          "https://www.iconfinder.com/data/icons/eldorado-user/40/user-512.png",
        active: true,
      },
      // sweetalert
      Toast: this.$swal.mixin({
        toast: true,
        position: "top-end",
        showConfirmButton: false,
        timer: 3000,
        timerProgressBar: true,
        didOpen: (toast) => {
          toast.addEventListener("mouseenter", this.$swal.stopTimer);
          toast.addEventListener("mouseleave", this.$swal.resumeTimer);
        },
      }),
    };
  },
  methods: {
    editItem(item) {
      this.editedIndex = this.students.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      const index = this.students.indexOf(item);
      const idStudent = this.students[index].id;
      this.$swal
        .fire({
          title: "Do you want to delete this student?",
          showDenyButton: true,
          showCancelButton: true,
          confirmButtonText: `Save`,
          denyButtonText: `Don't save`,
        })
        .then((result) => {
          if (result.isConfirmed) {
            this.$swal.fire("Deleted success!", "", "success");
            this.students.splice(index, 1);
            this.$store.dispatch("student/deleteStudent", idStudent);
          } else if (result.isDenied) {
            this.$swal.fire("Cancel", "", "info");
          }
        });
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      const student = this.students[this.editedIndex];
      if (this.editedIndex > -1) {
        Object.assign(this.students[this.editedIndex], this.editedItem);
        this.$store
          .dispatch("student/editStudent", student)
          .then(() =>
            this.Toast.fire({
              icon: "success",
              title: "Edit student success !",
            }))
          .catch(() => {
            this.$swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong edit student !",
            });
          });
      } else {
        this.$store
          .dispatch("student/addStudent", this.editedItem)
          .then(() =>
            this.Toast.fire({
              icon: "success",
              title: "Add student success !",
            }),
              this.students.push(this.editedItem)
            
          )
          .catch(() => {
            this.$swal.fire({
              icon: "error",
              title: "Oops...",
              text: "Something went wrong add student !",
            });
          });
      }
      this.close();
    },
    getActiveColor(active) {
      if (active == false) return "red";
      else return "green";
    },
  },
  computed: {
    students() {
      return this.$store.state.student.students;
    },
    formTitle() {
      return this.editedIndex === -1 ? "New Student" : "Edit Student";
    },
    headers() {
      return [
        {
          text: "Image",
          align: "start",
          sortable: false,
          value: "images",
        },
        {
          text: "Name",
          value: "full_name",
          filter: (f) => {
            return (f + "").toLowerCase().includes(this["name"].toLowerCase());
          },
        },
        {
          text: "Gender",
          value: "gender",
          filter: (f) => {
            if (!this.genderFilter || this.genderFilter === "all") return true;
            return f === this["genderFilter"];
          },
        },
        {
          text: "Car",
          value: "car_id",
          filter: (f) => {
            return (f + "").toLowerCase().includes(this["car"].toLowerCase());
          },
        },
        {
          text: "Start",
          value: "points_start",
          filter: (f) => {
            return (f + "").toLowerCase().includes(this["start"].toLowerCase());
          },
        },
        {
          text: "Active",
          value: "active",
          filter: (f) => {
            if (!this.activeFilter || this.activeFilter === "all") return true;
            return f === this["activeFilter"];
          },
        },
        { text: "Actions", value: "actions", sortable: false },
      ];
    },
  },
  watch: {
    dialog(val) {
      val || this.close();
    },
  },
  created() {
    this.$store.dispatch("student/fetch");
  },
  components: {
    StudentsDetails,
  },
};
</script>
<style>
</style>
